ORGANIZACIN DE LA ESPECIFICACIN.

A continuacin se describe sucintamente la estructura, parcial, de la
especificacin Coq para un modelo de virtualizacin, donde se pone
especial nfasis en el manejo de la memoria.   


Exc.v: Define un tipo de retorno que permite representar y trabajar 
con funciones parciales.


Maps.v: Define diccionarios implementados con listados, utilizados
para representar funciones, principalmente parciales.


Maps_proof.v: Define propiedades bsicas de los mappings.


Memory.v: Se definen los tres tipos de direcciones: virtuales, fsicas
y de mquina. Se mantiene el tipo de direcciones fsicas, ya que esto
permite representar el requerimiento de que los SO visualizan la
memoria como bloques contiguos de direcciones. Las acciones ejecutadas
por los SOs hacen referencia a memoria fsica. Adems se define el
contenido de las pginas de memoria. Las pginas pueden ser de
lectura/escritura (RW), en cuyo caso contienen un valor opcional; page
table (PT), en cuyo caso contienen un mapping de direcciones virtuales
a direcciones de mquina; o no ser de ninguno de los tipos anteriores.


OS.v: Se definen las hypercalls que puede hacer un SO untrusted. Se
define la representacin de los sistemas operativos, que cuentan con
un identificador, y cuya informacin dinmica puede contener cero o
una hypercall, y la direccin de la page table actual del SO
(accesible por su direccin fsica). Finalmente se definen los modos
de ejecucin: usuario, en el cual opera un SO untrusted, y supervisor,
en el cual opera el hypervisor y los SO trusted, y el estado en el
cual un SO activo se encuentra (ejecutando o en espera).


State.v: Se modela el estado como un record que incluye los
componentes dinmicos del sistema (aquellos que son afectados por la
ejecucin de las acciones). Los componentes son:
  * Identificador del SO activo
  * Mapping entre un identificador de SO y la informacin dinmica del
    mismo.
  * Modo de ejecucin actual del sistema.
  * Estado del SO activo (ejecutando o en espera).
  * Hypervisor, modelado como un mapping entre direcciones fsicas y
    direcciones de mquina, para cada SO.
  * Memoria del sistema, modelada como un mapping entre direcciones de
    mquina y pginas. Una pgina est compuesta por su contenido y su
    propietario. El propietario puede ser el hypervisor, un SO o no
    existir.

El mapping entre direcciones fsicas y direcciones de mquina
(hypervisor) se incluye en el estado, ya que asumimos que cambia con
la ejecucin de las acciones page_pin (agrega un correspondencia al
mapping) y page_unpin (que elimina una correspondencia). Asimismo,
estas acciones modifican el propietario de la pgina de memoria.


Env.v: El enviroment est modelado como un record que distingue la
informacin esttica (de contexto) de la dinmica (que constituye lo
que llamamos el estado del sistema). Dentro de la informacin de
contexto, tenemos un mapping que indica cuales direcciones virtuales
son accesibles por los SO y cuales por el hypervisor, y la informacin
de si un SO es trusted o untrusted.


State_proof.v: Tcticas y lemas auxiliares sobre los estados del
sistema.


State_valid.v: Se define un estado vlido como aquel que cumple un
conjunto de propiedades o restricciones sobre sus componentes. Estas
restricciones debern ser invariantes respecto a la ejecucin de las
acciones del sistema.


State_effects.v: Se incluyen definiciones tiles para tener
encapsuladas las operaciones de modificacin de los componentes del
estado.


Actions.v: Es el set de acciones definidas sobre el sistema.


Exec.v: Especifica la semntica de la ejecucin de las acciones,
a travs de pre y post condiciones definidas sobre los estados.


Exec_invariant.v: Incluye las pruebas de invarianza de validez del
estado. Se definenen teoremas para la invarianza de cada Accin y
lemas auxiliares para la prueba de los mismos.


Isolation.v: Establece propiedades de Isolation sobre el modelo. 

Safety.v: Introduce la nocin de traza de ejecucin del sistema, como Streams de
estados. Se define lo que es una corrida (run) vlida y qu significa que una propiedad 
es safe. Se provee tambin un esquema para probar propiedades de safety,

Safe_Write.v: Generaliza, como una propiedad de safety, la propiedad (write_isolation)
de que no hay escritura interferente en un paso de ejecucin del sistema.





