(***********************************************************************
 * File: Safe_Read.v
 * $Revision: 446 $
 * $Date: 2011-01-11 16:03:27 -0200 (Tue, 11 Jan 2011) $
 * $LastChangedBy: jdcampo $
 ***********************************************************************
 * This is the proof that Read isolation is safe
 **********************************************************************)

Require Import Traces.
Require Import Read_Isolation.

Section Safe_Read.

Variable ctxt : context.

Lemma run_implies_read_isolation: 
   forall str, run ctxt str -> (lift_binary (read_isolation ctxt)) str.
Proof.
intro str; case str.
unfold lift_binary; simpl.
unfold run; simpl.
unfold init_state; simpl; intros e s (H_valid, H_trace).
inversion H_trace.
inversion H2.
unfold read_isolation.
apply read_isolation_proof with (s:=ex_state e)(s':=ex_state (hd s))(ctxt:=ctxt). 
Qed.

Lemma safe_read : safe ctxt (read_isolation ctxt).
Proof.
unfold safe.
intros str H_run.
apply (ForAll_coind (lift_binary (read_isolation ctxt)) (run ctxt)).
exact run_implies_read_isolation.
exact (run_inv ctxt).
assumption.
Qed.

End Safe_Read.
